package Guiguts::Greekgifs;    # gifs for Greek toolbar
use strict;
use warnings;

BEGIN {
	require Exporter;
	our @ISA = qw(Exporter);
	our (%grkgifs);

	# set the version for version checking
	our $VERSION = 1.00;
	our @EXPORT  = qw(%grkgifs);
	$grkgifs{calpha} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJGRmZKSqpOTq5BQSFFRWVDQyNHR2dLS6tPz+/AD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGZgAADcAAD8AAB3AJjAAKRmABL4AAB3
      AGweMKQCpxJ4EgABAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJhAAAAAABsAAAAAABwAAAAADBoAOMAABRhAAAAAHAuABYAAPhiAHcAAP9tMP8A4/9wFP8AAHwA
      MKIA4xIAFAAAAK0AADkAAOkAAHcAAAAAAAAA4BMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYw
      cwDjcgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiEABsIHEiwoMGDCBMqXMiwoUOBBgg8PEgAAIOJBAdUTIBxoIABCgAc6HhAogEACzoWMCAQAYKO
      EgUuAMDyYYAAAw8AEDBRQUEBIh0aKFCQAQCiDUMCWMoUwEuGA3gaBFpTYYKLBo36VKgxYUWsBwcg
      kHowJAKwBAM0xZmx6c6OcOPKlRsQADs=
      ';
	$grkgifs{cbeta} = '
      R0lGODlhGAAYAPcAAAQCBISGhMTKxERCRCQiJKSqpOTq5FRWVBQSFJSWlNTa1DQyNLS6tPz+/GRm
      ZAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOhDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABhlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJiAAAAAABlAAAAAAB0AAAAADBhAOMAABQuAAAAAHBiABYAAPhtAHcAAP9wMP8A4/8AFP8AAHwA
      MKIA4xIAFAAAAK0AADkAAOkAAHcAAAAAAAAA4BMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGP9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGAATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYw
      cwDjcgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WKKlpxJOEgAAAJw85vml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiBABsIHEiwoMGDCBMqXMiwoUIAECNCRDCggEMGEA0MZDAAwAKHEA06AOCgYUiDABCYBHDw5EKX
      AwsAOLCSoIIACBAoWCkR4gKNNTd2BBAgKEGZABIwhDkwAQACS1m2lPqQKkEDT6MePEB0IUYAAo4u
      IPmyZ0QCByw6XMu2rdu3AwMCADs=
      ';
	$grkgifs{cchi} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJjAAAAAABoAAAAAABpAAAAADAuAOMAABRiAAAAAHBtABYAAPhwAHcAAP8AMP8A4/8AFP8AAHwA
      MKIA4xIAFAAAAK0AADkAAOkAAHcAAAAAAAAA4BMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYw
      cwDjcgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiQAB8IHEiwoMGDCBMqXMiwIcIBACJKFDBQgEQAFBEWQBCxQcEFABgMWLiAY4KCCRg4LBBxwcAB
      CA44fGAg5EACI2c+IAAgwAMFPnU+ANlTgdCBCSIeJcgx6FEHDji6FDqAYlKVQglU7KlTgUeBB6Q6
      NOCgIEsEUxMWYKC14IGICL4evAgg54MAdDMu3cu3r86AADs=
      ';
	$grkgifs{cdelta} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJGRmZKSqpOTq5BQSFJSWlFRWVDQyNHR2dPz+/AD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJkAAAAAABlAAAAAABsAAAAADB0AOMAABRhAAAAAHAuABYAAPhiAHcAAP9tMP8A4/9wFP8AAHwA
      MKIA4xIAFAAAAK0AADkAAOkAAHcAAAAAAAAA4BMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYw
      cwDjcgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiCABsIHEiwoMGDCBMqXMiwoUOBBQ48PAigwMSCAQAguEiQgAIAATg2MFBgAAACIglIFADAwMUB
      CgQaALDgooABAwkAwOnwgACCCQDEdFjAJUEEACQ2RFmQAQAGDQMkMHhA41KEBQBMVWgA6kGTTBOq
      TMjS6FcAaNOqTftTpNu3cDkGBAA7
      ';
	$grkgifs{cdigamma} = '
      R0lGODlhGAAYAPcAAAQCBKyyrPTy9NTW1FRSVLy+vGxqbLSytPz+/FxWXMTCxDw6PPT29NzW3FRW
      VLzCvHx6fLS2tGTKAF8aAGfaAAG2AICK1wFSKwA6QQCa/wCu1wAuFo56JwEGpQAW1wCaFq/yTFkq
      UNf6xivKFv/aABUGAACGAADGAABKjwAmFgDuLgCqdAwWAHPSAAluAlI2dACSAAGyAAB2jgAOAJ8e
      dtCOAABeAAA+AICyVqR+H3b2AAAuAM7+AOnOAEvexQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANm3AP8BAP8AEP8AAAAXAABqAAAAGAABAO8AAOgAAEuf
      AADQwNgAO7AA0HYnEgBqACcAAAAAAAAnIwAcApiPAKSxAHb5AAC/AGwDRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfzur04TF/X34L+/u/9sYv+jgP92yv8AFf9Qr//wF/+az/+BFpcQ
      xgNSFgCfAACBAABzAACxAAD5dQC/AQgAzwAwFgB2ZAAAdOIOABOhAPf3AL+/AH8mBwGzAAD3AAC/
      AGQAh87wAfeadb+BAfcAAEEAAPcAAL8AABQAAFIAAJ8AAIEAAPp/ANoIAPf6AL+/AJDgAJRVAPxQ
      AL8AAJeUrwOjFwB2hwAAAUBWJwCrAAD4AAC/AIwI/6Lm/3YA/wCA/yQgJ9tcAPcAAL+AAFwg2Deq
      sKkAdoGAAECYAAAQAAABAACAABQAuFIBpJ8AdoEAABMQCAGqtQAAS8CAABTkmFIcpJ9UdoEAAEB/
      8wAIsgD6TgC/AJf8zANOpAD1dgC/AIC0f0ukCAN2+tIAv9Trb6O2p3b5dgC/AP0E1/Tw//dO/78A
      f/8MSP/wp/9Odv8AAIDc5ACbHAD8VAC/AAO0fwCjCAB2+gAAv0MA5DoBHFwAVGIAAG/gAG9VAGtQ
      AHMAAFwAr3IASXQAR2bQAFyMSHAIp3IAdmUAAHAcSFwsp3Q8dmXQACH5BAAAAAAALAAAAAAYABgA
      BwhrABEIHEiwoMGDCBMqXMiwocOHEB9GMOCAQAICGC8OcBgBwIICCkIGWKDAYQEABAoeKNlQAQAH
      EQmeTBlToEuYNRGcBMATAMuHNxEwoAlxps2YQXMazZk0ZgMIPAMIiDlAAUgFDHJq3cpVa0AAOw==
      ';
	$grkgifs{cepsilon} = '
      R0lGODlhGAAYAPcAAAQCBISGhMTKxOTq5CQiJLS6tJSWlNTa1Pz+/DQyNAASEwAAAAD/RQD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOVDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABtlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJlAAAAAABwAAAAAABzAAAAADBpAOMAABRsAAAAAHBvABYAAPhuAHcAAP8uMP8A4/9iFP8AAHxt
      MKIA4xJwFAAAAK0AADkAAOkAAHcAAAAAAAAA4BMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QG/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYw
      cwDjcgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0W6KlpxJOEgAAAJw84/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhiABEIHEiwoMGDCBMqXMiwoUIAECNKhNiwAEWCAxIAcHiRoEWOGw2GZNjRYcGSCEY2LBlAJcmJ
      KBeydCnTJc2HN03GNJnypoAEK28SMMDQIoADBA9oHFATZkSgPKNKnUqVYUAAOw==
      ';
	$grkgifs{ceta} = '
      R0lGODlhGAAYAPcAAAQCBLS6tPz+/AAAdwAAAAIAAAAAEwAAAAqweACjEwASEwAAAAD/RQD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJlAAAAAAB0AAAAAABhAAAAADAuAOMAABRiAAAAAHBtABYAAPhwAHcAAP8AMP8A4/8AFP8AAHwA
      MKIA4xIAFAAAAK0AADkAAOkAAHcAAAAAAAAA4BMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYw
      cwDjcgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhiAAUIHEiwoMGDCBMqXMiwoUIAECMOjCgxYQCIAQpeBJBxIcSDHxmGLDjyIQCQJ0WmJLnSJMqG
      FGOWTDhTYM2XBm/mbDmRJ8KbOlni9OhTQNCBGzsixWiSYk+nDqNKnUq1akAAOw==
      ';
	$grkgifs{cgamma} = '
      R0lGODlhGAAYAPcAAAQCBKSqpOTq5DQyNLS6tPz+/AAAEwAAAAqweACjEwASEwAAAAD/RQD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJnAAAAAABhAAAAAABtAAAAADBtAOMAABRhAAAAAHAuABYAAPhiAHcAAP9tMP8A4/9wFP8AAHwA
      MKIA4xIAFAAAAK0AADkAAOkAAHcAAAAAAAAA4BMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYw
      cwDjcgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhTAAsIHEiwoMGDCBMqXMiw4UIAECNKhNgwAEWCAgYAcHiRIIGNDTsSBMlQpMORJE+iVGnQJEuX
      KmGelMkxJcsCNEPaVGkRQICbOCcCHUq0qNGBAQEAOw==
      ';
	$grkgifs{chalpha} = '
      R0lGODlhGAAYAIUAAf///+fr5wAAAFJVUqWqpSEgIRAQELW6tWNlY8bLxnN1c0JBQjEwMYSGhAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAGAAYAAUGeUCAcEgsGo/IpHLJ
      bCoDgsGQUHAKCQZiQXCwIrrCxFbqVBAXCYYgYB0GqgSBuQ1AEISGLL0qVAjuVg0NbgILbQxFC2tO
      BAhFBwKOTWoClZYCeksJhkaKgEoDYI8CiEpiSVuiRgkGnEdqBqpDDZeDRAmXhXS7vL2+REEAOw==
      ';
	$grkgifs{chepsilon} = '
      R0lGODlhGAAYAIUAAf///+fr5wAAAFJVUqWqpRAQELW6tdbb1jEwMWNlY3N1c4SGhMbLxpSWlAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAGAAYAAUGW0CAcEgsGo/IpHLJ
      bCIDggFAQK1aqUhCYWjAEg8IATJhIHqJBPFRUTybnW6nWT2kN90LO/NalU/teX5xektxfn+HbYQA
      DAh3iwgNTF0CB19hAYV8Vo6Jnp+goUEAOw==
      ';
	$grkgifs{cheta} = '
      R0lGODlhGAAYAIUAAf///+fr5wAAAFJVUqWqpRAQELW6tWNlY3N1cwAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAGAAYAAUGXECAcEgsGo/IpHLJ
      bB4DggFAQK0Sq9YhoTA0UA1GrwBMPJCFVGS6iCiuje9k/Cpgzod3eP2Yd2P/fXRqe0p9gXiEfnaJ
      gkuGjHyQaJJEYmddX3J/dFhOnp+goaFBADs=
      ';
	$grkgifs{chiota} = '
      R0lGODlhGAAYAIUAAf///+fr5wAAAFJVUqWqpRAQELW6tWNlY3N1cwAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAGAAYAAUGRECAcEgsGo/IpHLJ
      bC4DggFAQK06CYWhgWpwAg7dIdULQBTH5LMgrWYT0e7pOi6n1+lwd569T/e9WwJhflV/doeIiUNB
      ADs=
      ';
	$grkgifs{chomega} = '
      R0lGODlhHAAZAIUAAf///+fr5wAAAFJVUmNlYyEgIcbLxqWqpRAQEISGhNbb1rW6tXN1c0JBQjEw
      MZSWlAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAHAAZAAUGiECAcEgsGo/IpHLJ
      bDqf0GRAMBAGCAWBoEAwPA8IYYKqECoGAoKTsACME8ZDuskAKAQNZEPgbRIEbUcLVE5ZSgJhTVqH
      Ak6LSY9MDgJlR1MOTgwCD0hycE0BCAVIDolOcg0BRAFogU8GBXlDDQ19ipUAmLNDd0xav41DwJGQ
      w0TDwVHKy8zNzUEAOw==
      ';
	$grkgifs{chomicron} = '
      R0lGODlhGAAYAIUAAf///+fr5wAAAFJVUqWqpRAQEEJBQjEwMbW6tWNlY3N1c8bLxiEgIZSWlNbb
      1gAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAGAAYAAUGgECAcEgsGo/IpHLJ
      bCIDgsGQMCgIBAbCklAQBg4HxBQcSCbEgILUWC0fFUJDF1kwKAkCOFIh0CIHAgtJC1FJVksCc0dX
      iAJJjEqQRwyOkQxJgGhHhAlJeJ1IDYFKBwVuRgx2Sg4FB0cJrkwOBwx+AAQMsU4EBldqtk7BwsPE
      xUJBADs=
      ';
	$grkgifs{chupsilon} = '
      R0lGODlhGAAYAIUAAf///+fr5wAAAFJVUqWqpRAQECEgIYSGhEJBQpSWlGNlY7W6tTEwMXN1c9bb
      1sbLxgAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
      AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAAGAAYAAUGbECAcEgsGo/IpHLJ
      bBoDggFAQK0KitarkFAYEgzUwxEhSBAViyKjPCYUG0aHoBAoLuDNgwBRNDiFZGJCaH8AAQUCDgAP
      fIUACQIMAAx1jgADAgaCllNanJ2fQlShoKGjnwtUaZZZnqSvsLFGQQA7
      ';
	$grkgifs{ciota} = '
      R0lGODlhGAAYAPcAAAQCBLS6tPz+/AAAdwAAAAIAAAAAEwAAAAqweACjEwASEwAAAAD/RQD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOhDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABhlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJpAAAAAABvAAAAAAB0AAAAADBhAOMAABQuAAAAAHBiABYAAPhtAHcAAP9wMP8A4/8AFP8AAHwA
      MKIA4xIAFAAAAK0AADkAAOkAAHcAAAAAAAAA4BMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGP9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGAATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYw
      cwDjcgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WKKlpxJOEgAAAJw85vml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhLAAUIHEiwoMGDCBMqXMiwoUMAECM6LBgAYoCJBiFizAhgY0GNHgeCDClgZEiTHlFuVImR5USX
      DzuSLCkzZEUAF1NGhDmzp8+fBgMCADs=
      ';
	$grkgifs{ckappa} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRNTa1CQiJGRmZKSqpPz+/BQSFFRWVOTq5DQyNHR2dLS6tAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJrAAAAAABhAAAAAABwAAAAADBwAOMAABRhAAAAAHAuABYAAPhiAHcAAP9tMP8A4/9wFP8AAHwA
      MKIA4xIAFAAAAK0AADkAAOkAAHcAAAAAAAAA4BMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYw
      cwDjcgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh9AA8IHEiwoMGDCBMqXMiwoUIAECMOjAhRgMIGEBsUFACgwACGEA0S+Ngw5EAFBRQ4PGDywACL
      K1kCEGigQEyBIQPYvCmzAACSNyH6RAB0ZUifBHia9Lkg6EyBTGO2PBDV4dQDDAAgCMAQIwCNBBNA
      3JqQYkuOZnmqXcuWbUAAOw==
      ';
	$grkgifs{ckoppa} = '
      R0lGODlhGAAYAPcAAAQCBISKhNze3KSmpFRSVGxqbLS2tJSalOzy7KyyrHR6dIyKjGRmZPz+/Hx6
      fDw6POTi5KyqrFRWVLy+vJyanPT29LSytIyOjHx+fACa/wCu1wAuFo56JwEGpQAW1wCaFq/yTFkq
      UNf6xivKFv/aABUGAACGAADGAABKjwAmFgDuLgCqdAwWAHPSAAluAlI2dACSAAGyAAB2jgAOAJ8e
      dtCOAABeAAA+AICyVqR+H3b2AAAuAM7+AOnOAEvexQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANu3AP8BAP8AEP8AAAAXAABqAAAAGAABAO8AAOgAAEuf
      AADQwNgAO7AA0HYnEgBqACUAAAAAAAAnIwAcApiPAKSxAHb5AAC/AGwDRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfzur04TF/X34L+/u/9sYv+jgP92yv8AFf9Qr//wF/+az/+BFsQQ
      xgNSFgCfAACBAABzAACxAAD5dQC/AQgAzwAwFgB2ZAAAdOIOABOhAPf3AL+/AH8mBwGzAAD3AAC/
      AGQAh87wAfeadb+BAfcAAEEAAPcAAL8AABQAAFIAAJ8AAIEAAPp/ANoIAPf6AL+/AJDgAJRVAPxQ
      AL8AAMSUrwOjFwB2hwAAAUBWJQCrAAD4AAC/AIwI/6Lm/3YA/wCA/yQgJdtcAPcAAL+AAFwg2Deq
      sKkAdoGAAECYAAAQAAABAACAABQAuFIBpJ8AdoEAABMQCAGqtQAAS8CAABTkmFIcpJ9UdoEAAEB/
      8wAIsgD6TgC/AMT8zANOpAD1dgC/AIC0f0ukCAN2+tIAv9TrbaO2p3b5dgC/AP0E2fTw//dO/78A
      f/8MSP/wp/9Odv8AAIDc5ACbHAD8VAC/AAO0fwCjCAB2+gAAv0MA5DoBHFwAVGIAAG/gAG9VAGtQ
      AHMAAFwAr3IASXQAR2bQAFyMSHAIp3IAdmUAAHAcSFwsp3Q8dmXQACH5BAAAAAAALAAAAAAYABgA
      Bwh6ABsIHEiwoMGDCBMqXMiwocOHByNQMACxYIAFACRULIgBwEaCDxx8FCgAQIKRDQZ4JGiBwkMC
      BUheAABAZEMEAAYMeECTJsWGBnoCeGDgwMqGDGgugCDwgYKHFyYQrGASZQIAFVAWIICywdAGWT8G
      pdl1AtOuaNMmDAgAOw==
      ';
	$grkgifs{clambda} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOZDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABplAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJsAAAAAABhAAAAAABtAAAAAHBiALcAABVkAAAAAHBhABYAAPguAHcAAP9icP8At/9tFf8AAHxw
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WqKlpxJOEgAAAJw85Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiDAB8IHEiwoMGDCBMqXMiwocMHDQw8PKgAwUSDAAAEuDgwgQEAFjk+IHDgYwGOAwQ8OACAAEcD
      Jx8oABDzoUuBAwCofFjAAUEBAAY8ZLCAYM6dDBcwMAj0QEMHNQfmlMjwpkECAJwq9IiwAACqCBMA
      UIAwQMYECDOqxag2o8i3cONyDAgAOw==
      ';
	$grkgifs{cmu} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOpDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABZlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJtAAAAAAB1AAAAAAAuAAAAAHBiALcAABVtAAAAAHBwABYAAPgAAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VqKlpxJOEgAAAJw86Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwirAB8IHEiwoMGDCBMqXMiw4UEAEAE4SLggIgCDASAiSGgAYgOEABAAKICQAMSEADoSOFig40WQ
      ByAOMKhgwEmQDwSkLHhg5c2HDxpAPEAwQYAHPw2+NHl0IAGiSQu+TABgpcAFCgRGJfjygUiSDwyA
      3Tqwa0cBAq0i7ap0YEwABxoYKMtWKkGdBhQsoIuSoFAEDLjWHSj0o1MACQh7VGpxIFW6jR1Knky5
      cuWAADs=
      ';
	$grkgifs{cnu} = '
      R0lGODlhGAAYAPcAAAQCBISGhMTKxERCRCQiJKSqpOTq5HR2dBQSFJSWlNTa1FRWVDQyNLS6tPz+
      /AD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOpDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABZlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJuAAAAAAB1AAAAAAAuAAAAAHBiALcAABVtAAAAAHBwABYAAPgAAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VqKlpxJOEgAAAJw86Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiCAB0IHEiwoMGDCBMqXMiwIUIBACICOGBQYsSEChZEbGCwAQCOCyMiMFCxIQAGJ0syBKAAwcSC
      AEw6KLCRYMyVAjUisClTIAEAAwbeDDlQQcQAAocqVJogogAHShNG1Qm1J8GfA6Ii1Gr0Ik6DTbV2
      /HhQY0iLBwk4TEhyrdu3cBcGBAA7
      ';
	$grkgifs{comega} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJvAAAAAABtAAAAAABlAAAAAHBnALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiTAB8IHEiwoMGDCBMqXMiwYcMDBggAAEDAwACHDwIAULBA4AIFAAw01BjAYIGQCxcAEIBQAICL
      CQ0AaICwwUaFEhUCQKATQM+fCScqZACg48EDABgodAAgAcKTJRMeQEAAIQOeC08KOEDwAEiaDAcQ
      YDlQgACYQY0+UFp2oEqEE+P6HChX6MG6cwXixci3r9+/GAMCADs=
      ';
	$grkgifs{comicron} = '
      R0lGODlhGAAYAPcAAAQCBJSWlERCRNTa1CQiJLS6tGRmZPz+/BQSFKSqpFRWVOTq5DQyNMTKxHR2
      dAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOVDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABtlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJvAAAAAABtAAAAAABpAAAAAHBjALcAABVyAAAAAHBvABYAAPhuAHcAAP8ucP8At/9iFf8AAHxt
      cKIAtxJwFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QG/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0W6KlpxJOEgAAAJw84/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiOAA8IHEiwoMGDCBMqXMiwYcMEChAAACAggcMDCxgwKDAwgcYFDREoOBgRpEIBCBIiEKAwAQAH
      CR0AsIhQAYAGCRsAGIlQ4kIAKRFO/Akg4VCFRw8SKIqUQEKbHBHqNJDQJVWEAW4qZIDApEECLBUO
      QMDgoIGyDAcwIEDzQAICaB0mEDBRZNuLePPq3Zs3IAA7
      ';
	$grkgifs{cphi} = '
      R0lGODlhGAAYAPcAAAQCBJyenPz+/Hx+fLy+vHEAdIB6AFpzAAADugAAZ0cnALwGAADFAAA/0I8v
      OgEC0ACsAgABAgAzAAACAOy5AHEBAEEtL1kCdgCqQQAB/wAT1wAEFgC8JwABpQAA1wAwFq9oTFnP
      UC8AxnbQFv85ABXQAAAAAAAAAAAAjwAAFgAzLgACdAwAAHMAAAkzAlICdAC3AAEBAABEjgBzAIcA
      dhsAAAACAAACAIAAVqQAH3ZJAAAAAM4AAOkAAEsPxQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANS3AP8BAP8AEP8AAABPAAA7AAAAGAABAO8AAOgAAEuH
      AAAb8NgAOrAA0HY3EgCRACwAAAAAAABfIwCnApiPAKSxAHb5AAC/AGwCRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfwAr04AF/Vq4L/3u/8DYv8AgP8Iyv90Ff8Dr/8AF/8nz/8GFhRW
      xgEfFtYvAAECADhzAJSxAC/5dbG/ASQAz3MwFgJ2ZAAAdEeqAAABAE8TADsEAAK8BwABAKoAAIIw
      APVoh7/PATwAdY7QAbc5AATQAOAAALsAAGwAAAQAAJYAAAcAAAB/AAAIAKL6AGa/ACfgAAZVAABQ
      AAAAACmUrwCjF892hxYAAQdWLACrAAD4AAC/AI5A/3L8/8QA/0aA/wBYLADnAAAAAACAAIcw2AHR
      sAAAdgCAAJiAAKJbAHYAAACAAHsAuLcBpPcAdr8AAPdICEF7tfcAS7+AAJDkmJQcpPxUdr8AAJZ/
      87cIsvf6Tr+/AJD8zJROpPz1dr+/AIe0fwGkCAB2+gAAv7DrdKK2p3b5dgC/ACgE0rjw//dO/78A
      f2wMSATwp6ROdoEAAPfc5EGbHPf8VL+/AJC0f5SjCPx2+r8Av04A5LgBHPcAVL8AAAHgAABVAABQ
      AAAAAAEArwAASTMARwLQALeMSAEIp88AdkAAAAAcSABcp0Y7dpfQACH5BAAAAAAALAAAAAAYABgA
      BwiCAAUIHEiwoMGDCBMqXMiwoUMAECM6LBgAYoCJAgkMGBAR4gACDTkGAAlRAIGKAxZyBCmwZEYA
      KRFWvDjQpcCZCFcStGkSJkKeAoACrQmgoNCiB3USJUjA50GcSwdCTQqAZVCkPWMmFEmy6EmnCzV2
      9GjVYUUANDFe7ai2rdu3cBUGBAA7
      ';
	$grkgifs{cpi} = '
      R0lGODlhGAAYAPcAAAQCBKSqpPz+/LS6tAAAAAIAAAAAEwAAAAqweACjEwASEwAAAAD/RQD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOpDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABZlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJwAAAAAABpAAAAAAAuAAAAAHBiALcAABVtAAAAAHBwABYAAPgAAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VqKlpxJOEgAAAJw86Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhgAAUIHEiwoMGDCBMqXMiwYUIAECNKnKgwAMSDEAMwvGiQ40KPBEE+BICR5EaTBUUiVCmAZUeU
      IWGOLNmQpcuUMgXejEnzZM+POVsGLWgRwACiGRVORLnUodOnUKNKFRgQADs=
      ';
	$grkgifs{cpsi} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJOTq5KSqpFRWVBQSFNTa1DQyNPz+/LS6tGRmZAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJwAAAAAABzAAAAAABpAAAAAHAuALcAABViAAAAAHBtABYAAPhwAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiAABcIHEiwoMGDCBMqXMiwYUIABwYCmEhx4AEACAcACDCQwUQGAxsAGPCQAMGJBAlgfLhSIEqJ
      LQ++dBlz5kEFABLAHJgAgAKFATbuFBiUo0IBGwssQFkgqICGBg4goAgAwQEDDk/GzDqUq1avBW2C
      FcvVIwCQY6luBcu2rdu3AQEAOw==
      ';
	$grkgifs{crho} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJGRmZOTq5KSqpBQSFFRWVNTa1DQyNHR2dPz+/LS6
      tAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJyAAAAAABoAAAAAABvAAAAAHAuALcAABViAAAAAHBtABYAAPhwAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhpABsIHEiwoMGDCBMqXMiw4UIAECMCQCDggMMGDiAaEDggAYACFyEW9BjAoUiCCgAQMAnA4EmG
      LwUamMiyYAEADFhabGDA44KQEgEsKAn04sGYRgUiTbrUaFOHGQE4SKo0KNWrWLNqRRgQADs=
      ';
	$grkgifs{csampi} = '
      R0lGODlhGAAYAPcAAAQCBIyKjNTW1KyqrFRSVOzy7Ly+vGRqZJSalNze3KyyrPz+/Hx6fDw6PPTy
      9KSmpLSytJSWlNzW3FRWVMTCxGxqbJyanOTi5Hx+fDw+PPT29LS2tI56JwEGpQAW1wCaFq/yTFkq
      UNf6xivKFv/aABUGAACGAADGAABKjwAmFgDuLgCqdAwWAHPSAAluAlI2dACSAAGyAAB2jgAOAJ8e
      dtCOAABeAAA+AICyVqR+H3b2AAAuAM7+AOnOAEvexQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANu3AP8BAP8AEP8AAAAXAABqAAAAGAABAO8AAOgAAEuf
      AADQwNgAO7AA0HYnEgBqACUAAAAAAAAnIwAcApiPAKSxAHb5AAC/AGwDRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfzur04TF/X34L+/u/9sYv+jgP92yv8AFf9Qr//wF/+az/+BFuAQ
      xgNSFgCfAACBAABzAACxAAD5dQC/AQgAzwAwFgB2ZAAAdOIOABOhAPf3AL+/AH8mBwGzAAD3AAC/
      AGQAh87wAfeadb+BAfcAAEEAAPcAAL8AABQAAFIAAJ8AAIEAAPp/ANoIAPf6AL+/AJDgAJRVAPxQ
      AL8AAOCUrwOjFwB2hwAAAUBWJQCrAAD4AAC/AIwI/6Lm/3YA/wCA/yQgJdtcAPcAAL+AAFwg2Deq
      sKkAdoGAAECYAAAQAAABAACAABQAuFIBpJ8AdoEAABMQCAGqtQAAS8CAABTkmFIcpJ9UdoEAAEB/
      8wAIsgD6TgC/AOD8zANOpAD1dgC/AIC0f0ukCAN2+tIAv9TrbaO2p3b5dgC/AP0E2fTw//dO/78A
      f/8MSP/wp/9Odv8AAIDc5ACbHAD8VAC/AAO0fwCjCAB2+gAAv0MA5DoBHFwAVGIAAG/gAG9VAGtQ
      AHMAAFwAr3IASXQAR2bQAFyMSHAIp3IAdmUAAHAcSFwsp3Q8dmXQACH5BAAAAAAALAAAAAAYABgA
      BwidABcIHEiwoMGDCBMqXMiw4cIEFghMIGABgsMFGgIAADABgYUGGw0w1NAggAMLEQYa2Ghh4YMN
      Aj0SdLBxgEOUBTUCENDQQkuBCQhUqADgQM8HAgUAgKkUgIOLCwBgGBjyooKdAwkASOkQAwCCEwD8
      bCiRoFaLDicSzAAgwcWyVL9eTMBTIAQAaKEOZNBAL0ENACT4HQgB5uDDiAcHBAA7
      ';
	$grkgifs{csigma} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJzAAAAAABpAAAAAABnAAAAAHBtALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh7AB8IHEiwoMGDCBMqXMiw4UICACJKnCiA4QIEABYUXMCgIsMGABAcKNiAgMMEABgYBODwgQEA
      CloeZAAggEyDGAvcJHgRwU6CAnT+dCn0ZwEHQx8UMGDwAEuGA2IaDOBR4YKqAw+glJrwAMaJYG0q
      pAkWbNGkaNOqRRgQADs=
      ';
	$grkgifs{cstigma} = '
      R0lGODlhGAAYAPcAAAQCBIyKjNTW1KyqrFRSVJSalOzy7Ly+vGxqbKyyrPz+/JSWlFxWXKSmpPTy
      9Hx6fLSytDw6PIyOjNze3FRWVJyanMTCxPT29Hx+fLS2tAD21wC2Fo56JwEGpQAW1wCaFq/yTFkq
      UNf6xivKFv/aABUGAACGAADGAABKjwAmFgDuLgCqdAwWAHPSAAluAlI2dACSAAGyAAB2jgAOAJ8e
      dtCOAABeAAA+AICyVqR+H3b2AAAuAM7+AOnOAEvexQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANq3AP8BAP8AEP8AAAAXAABqAAAAGAABAO8AAOgAAEuf
      AADQwNgAO7AA0HYnEgBqACYAAAAAAAAnIwAcApiPAKSxAHb5AAC/AGwDRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfzur04TF/X34L+/u/9sYv+jgP92yv8AFf9Qr//wF/+az/+BFvsQ
      xgNSFgCfAACBAABzAACxAAD5dQC/AQgAzwAwFgB2ZAAAdOIOABOhAPf3AL+/AH8mBwGzAAD3AAC/
      AGQAh87wAfeadb+BAfcAAEEAAPcAAL8AABQAAFIAAJ8AAIEAAPp/ANoIAPf6AL+/AJDgAJRVAPxQ
      AL8AAPuUrwOjFwB2hwAAAUBWJgCrAAD4AAC/AIwI/6Lm/3YA/wCA/yQgJttcAPcAAL+AAFwg2Deq
      sKkAdoGAAECYAAAQAAABAACAABQAuFIBpJ8AdoEAABMQCAGqtQAAS8CAABTkmFIcpJ9UdoEAAEB/
      8wAIsgD6TgC/APv8zANOpAD1dgC/AIC0f0ukCAN2+tIAv9TrbqO2p3b5dgC/AP0E2PTw//dO/78A
      f/8MSP/wp/9Odv8AAIDc5ACbHAD8VAC/AAO0fwCjCAB2+gAAv0MA5DoBHFwAVGIAAG/gAG9VAGtQ
      AHMAAFwAr3IASXQAR2bQAFyMSHAIp3IAdmUAAHAcSFwsp3Q8dmXQACH5BAAAAAAALAAAAAAYABgA
      BwiGABUIHEiwoMGDCBMqXMiwYcMLAx4QoEAgwASHCjIAANDAwgGNAAY0TLDRAUGNFBhe2Ciy4AAL
      DAdsxGiwAgAGNAsuAEAg58mSPgdGABChpc8JDDYCQNBAgE8BASgoBZAgqAILNgEssCqQAACuCiR8
      9WngQACiNKduxGASI4QKHZ2CnUuXYUAAOw==
      ';
	$grkgifs{ctau} = '
      R0lGODlhGAAYAPcAAAQCBLS6tPz+/DQyNNTa1MTKxERCRAAAAAqweACjEwASEwAAAAD/RQD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJ0AAAAAABhAAAAAAB1AAAAAHAuALcAABViAAAAAHBtABYAAPhwAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhYAAUIHEiwoMGDCBMqXMiwoUIAECNKlPhwAIGBEAcWGADgYQCCGQcG6JjQQMGQA006FIByJUiS
      Ll/GPAlzJsuaM1vmxBlTZ0+eLn2uHAng406KNpMqXbo0IAA7
      ';
	$grkgifs{ctheta} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJ0AAAAAABoAAAAAABlAAAAAHB0ALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwigAB8IHEiwoMGDCBMqXMiwocMCChAAACCggEOBAhg0GFiAAYMDDA8gUHBQAAKQChkgSIiAgcIC
      ABwkdADAIkIFAAY8AFCQ5wAAJBFKFAggwMAAPHeuRDiR6MSnSZsyjQpVqtSDBKIaFYiUKIGEBgBs
      TDrQJwADCX+iRYhUZ0KTKA0iELBQpEuDCu4uXEBAI0cGdC8mEDBxpM2LiBMrXpw4IAA7
      ';
	$grkgifs{cupsilon} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJGRmZOTq5KSqpBQSFFRWVNTa1DQyNHR2dPz+/LS6
      tAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOVDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABtlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJ1AAAAAABwAAAAAABzAAAAAHBpALcAABVsAAAAAHBvABYAAPhuAHcAAP8ucP8At/9iFf8AAHxt
      cKIAtxJwFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QG/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0W6KlpxJOEgAAAJw84/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhyABsIHEiwoMGDCBMqXMiwYUIAECMGGBggIsSEBxAASGDQAAACDhYq+NiRgEMGAAoUFDDAYQMC
      AFoKdKDSpQOSAhcYcClQAICJASbybOARwQCTQwVWjJl04MWmAp9CldqUalKrPG8CCHnVIgCoYMOK
      bRoQADs=
      ';
	$grkgifs{cxi} = '
      R0lGODlhGAAYAPcAAAQCBISGhPz+/HR2dLS6tAIAAAAAEwAAAAqweACjEwASEwAAAAD/RQD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOpDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABZlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJ4AAAAAABpAAAAAAAuAAAAAHBiALcAABVtAAAAAHBwABYAAPgAAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VqKlpxJOEgAAAJw86Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhYAAUIHEiwoMGDCBMqXMiwIUMAECNKBNBwosWKAw4GoPgwIUeHIBF+FDiyIoGBBEo+vBjSosqF
      AE4KTBlSQMmXNR3iHLiTZICEG2G6nCh0aMScSJMqXSogIAA7
      ';
	$grkgifs{czeta} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOhDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABhlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhjALEA
      ABJ6AAAAAABlAAAAAAB0AAAAAHBhALcAABUuAAAAAHBiABYAAPhtAHcAAP9wcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGP9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGAATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WKKlpxJOEgAAAJw85vml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh6AB8IHEiwoMGDCBMqXMiw4UIAECNKBMCAIQAEAwouuHjAYgGDDAAkaAjAoAMAChwaHHBRpUEC
      ADK6HKgAgIOZAxtQxCnwAAIAC3g+EAAggNAEAAQI3Yig40qGIT8aXEBg4cmUBw1gRcgSAUKkRhP+
      nEhWptCzaNM2DAgAOw==
      ';
	$grkgifs{halpha} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhoALEA
      ABJhAAAAAABsAAAAAABwAAAAAHBoALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiEAB8IHEiwoMGDCBMqXMiwocMHBwAoeGiwAAKKBg00wFjQAcePCA0AAOAxIoGHDAgceGAgQQOJ
      DhMAKDCQQQAACRwKALBgoEwAAxyOLDhUKACCCwAIeFhUYAGSKAGsFCiSpsObVk0aoIhA5QMGQAUs
      WHCR4QEFIwUEbYAAgVWQcOPKdRgQADs=
      ';
	$grkgifs{hepsilon} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJGRmZKSqpOTq5BQSFFRWVDQyNHR2dLS6tPz+/AD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOVDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABtlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhoALEA
      ABJlAAAAAABwAAAAAABzAAAAAHBpALcAABVsAAAAAHBvABYAAPhuAHcAAP8ucP8At/9iFf8AAHxt
      cKIAtxJwFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QG/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0W6KlpxJOEgAAAJw84/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhwABsIHEiwoMGDCBMqXMiwocMGBwAkeGjQAAKKBgswwFhwAcePCBkIAAAAQYEDFAMAKCCwAAAC
      FBEAIKhAQcyZIBsYABAgZ4MBJAsggElxZ0+QMn3KRDmQgE2HOxWgPODyqcMBCWQCEGDAp9evYBcG
      BAA7
      ';
	$grkgifs{heta} = '
      R0lGODlhGAAYAPcAAAQCBJyenPz+/Hx+fLy+vHFldIByAFpzAABcugBwZ0dwALxcAABpAABs0I9s
      OgFc0ABjAgBwAgBoAABpAOwuAHFnAEFpL1lmdgAAQQAB/wAT1wAEFgC8JwABpQAA1wAwFq9oTFnP
      UC8AxnbQFv85ABXQAAAAAAAAAAAAjwAAFgAzLgACdAwAAHMAAAkzAlICdAC3AAEBAABEjgBzAIcA
      dhsAAAACAAACAIAAVqQAH3ZJAAAAAM4AAOkAAEsPxQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANS3AP8BAP8AEP8AAABPAAA7AAAAGAABAO8AAOgAAEuH
      AAAb8NgAOrAA0HY3EgCRACwAAAAAAABfIwCnApiPAKSxAHb5AAC/AGwCRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfzur04TF/X34L+/u/9sYv+jgP92yv8AFf9Qr//wF/+az/+BFpZ8
      xgLVFgCgAACBAABzAACxAAD5dQC/AQgAzwAwFgB2ZAAAdOIOABOhAPf3AL+/AH8mBwGzAAD3AAC/
      AGQAh87wAfeadb+BAfcAAEEAAPcAAL8AAIAAANUAAKAAAIEAAPp/ANoIAPf6AL+/AJDgAJRVAPxQ
      AL8AAJaUrwKjFwB2hwAAATRWLACrAAD4AAC/AIxA/6L8/3YA/wCA/yRYLNvnAPcAAL+AAGww2ATR
      sKQAdoGAADSAAABbAAAAAACAAIAAuNUBpKAAdoEAABNICAF7tQAAS8CAAIDkmNUcpKBUdoEAADR/
      8wAIsgD6TgC/AJb8zAJOpAD1dgC/APC0f9mkCA92+tIAv9TrdKO2p3b5dgC/AP0E0vTw//dO/78A
      f/8MSP/wp/9Odv8AAIDc5ACbHAD8VAC/AAO0fwCjCAB2+gAAv0MA5DoBHFwAVGIAAG/gAG9VAGtQ
      AHMAAFwAr24ASWUAR3fQACCMSHAIp3IAdm8AAGocSGVcp2M7dnTQACH5BAAAAAAALAAAAAAYABgA
      BwhlAAUIHEiwoMGDCBMqJEgAwICFCgMAgKhwAAGKCQNg3EixIQCNEh1utAjg40WJDylOLHlRYEmO
      LwfGxDhTQE2INW8uzDlxI0+YPV0GVTlUp8KfHAsa9Tk0qc2mSZdiHACgpdOFAQEAOw==
      ';
	$grkgifs{hiota} = '
      R0lGODlhGAAYAPcAAAQCBJSWlERCRNTa1GRmZCQiJKSqpPz+/BQSFFRWVOTq5HR2dLS6tAD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOhDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABhlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhoALEA
      ABJpAAAAAABvAAAAAAB0AAAAAHBhALcAABUuAAAAAHBiABYAAPhtAHcAAP9wcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGP9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGAATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WKKlpxJOEgAAAJw85vml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhUAA8IHEiwoMGDCBMqXMiwoUOBCgAkeGjQAAKKBgkwwFhwAcePCBUESAAAJAIAKEEeGJBSZUuQ
      Lz/G5DgTY02KLS9yLABgQAACHxnwFKCyqNGjDwMCADs=
      ';
	$grkgifs{homega} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhoALEA
      ABJvAAAAAABtAAAAAABlAAAAAHBnALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiWAB8IHEiwoMGDCBMqXMiwoUOBBwAoeGiwAAKKBg00wFjQAcePBhcYIABAIAACBhY0LACAwcaB
      DRgAKLBwwcmBBiYKlKkyoYGZAwGUFNgAgAGFJA8EHWqSgEKhBAFcXPqU6QMFOk1aNSiTYAKaQZ0m
      DABUIFaYRhcyIKA0AYIBCR4cYIBA6UIHCAAIUNmA5F6QgAMLphgQADs=
      ';
	$grkgifs{homicron} = '
      R0lGODlhGAAYAPcAAAQCBISGhFRWVMTKxCQiJOTq5KSqpHR2dBQSFGRmZNTa1DQyNPz+/LS6tAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOVDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABtlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhoALEA
      ABJvAAAAAABtAAAAAABpAAAAAHBjALcAABVyAAAAAHBvABYAAPhuAHcAAP8ucP8At/9iFf8AAHxt
      cKIAtxJwFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QG/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0W6KlpxJOEgAAAJw84/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh3ABkIHEiwoMGDCBMqXMiwoUOBBQAIeGjQAAKKBhM0wFjwAMePCAcIAABgwUaKFjcWGOnRYUQD
      BAkAGOAwAYCCBiQ6lFkw4s2GJA0GbYgAgIKCAAg4HBkAaQKHAwBcHJizwMMDJa0OQACTYoMFJAXQ
      BEm2rFmOAQEAOw==
      ';
	$grkgifs{hrho} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJGRmZOTq5KSqpBQSFFRWVNTa1DQyNHR2dPz+/LS6
      tAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhoALEA
      ABJyAAAAAABoAAAAAABvAAAAAHAuALcAABViAAAAAHBtABYAAPhwAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh9ABsIHEiwoMGDCA0ASICwIcEDCBxKbFDAwUSHDC5q3MhR4oAEABYO6MggYwOIAA5sdACAoAIE
      ACxeFNCSYAAACzSGLKhg50WfBIFKFCoQp86aA3sGODpyYAICG0MKGGmgAAIFUQEooImgQEeiX5F2
      LCq2o8KcYwWyFJA2bUAAOw==
      ';
	$grkgifs{hupsilon} = '
      R0lGODlhGAAYAPcAAAQCBJSWlFRWVNTa1CQiJLS6tHR2dPz+/BQSFKSqpGRmZOTq5DQyNMTKxAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOVDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABtlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhoALEA
      ABJ1AAAAAABwAAAAAABzAAAAAHBpALcAABVsAAAAAHBvABYAAPhuAHcAAP8ucP8At/9iFf8AAHxt
      cKIAtxJwFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QG/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0W6KlpxJOEgAAAJw84/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh5AA8IHEiwoMGDCBMqXMiwoUOBCwAIeGgwAQKKBhUUwFjQAMePBQcQQJBgIAIFDwU0AHBRYAME
      DBwCOABg5sAEAAI8rEkwYkyZNgfyBFpwaEOjAgEQ2Bn0wEqPDhkAGDDQAIIFDwsAYIA1AIKNFAtI
      lUgVpNmzaDkGBAA7
      ';
	$grkgifs{lalpha} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJhAAAAAABsAAAAAABwAAAAAHBoALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh8AB8IHEiwoMGDCBMqXMiwocOHECNKLGgAAAAHDw4AIPCQAYEDDwwkaABAgcMEAAoMZBAAQAKH
      AgAsGIgSwACHFgvmxAmA4AIAAh7uFFjgYkcAIAVWVOmwJVONBAxARPDxAQObAhYsQNDwgAKLAm42
      QICA6cSzaNOqXTsxIAA7
      ';
	$grkgifs{lbeta} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOhDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABhlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJiAAAAAABlAAAAAAB0AAAAAHBhALcAABUuAAAAAHBiABYAAPhtAHcAAP9wcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGP9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGAATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WKKlpxJOEgAAAJw85vml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiPAB8IHEiwoMGDBQ0gAIDAwAGECA8gQDDgwQAGCBZANGgAQIOBDQAI2FiQAICCAE6SHJgSpcqV
      D1oOPABAAUyBMgUGQPDwpkwCExPcxPnSIgAHQ3MK7FjAZ9EHIRk4Nah0Y9WYTyFWpWkTZtUAACp6
      rdkzwdGkHhmkFPAR7dCDV9/GvbkAAIG3BUN2xctXYEAAOw==
      ';
	$grkgifs{lchi} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJGRmZOTq5KSqpBQSFJSWlFRWVNTa1DQyNHR2dPz+
      /AD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJjAAAAAABoAAAAAABpAAAAAHAuALcAABViAAAAAHBtABYAAPhwAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh3AB0IHEiwoMGDCBMqXMiwocOHECNKJGiAAIADAwcAIOCwAAAACAYKuOiQQAMHCjBq5OgQgMAF
      BRyMxCiRwMqJMmfiDLARp0ySE2/iHOky6EYFAybOTJBA4s0FCgYWZajTgU0HARg0FOqgwUcAARpW
      FThSgE+FAQEAOw==
      ';
	$grkgifs{ldelta} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJkAAAAAABlAAAAAABsAAAAAHB0ALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiEAB8IHEiwoMGDCBMqXMiwYcMFCgAAQGDggMOBBBI8OMAAAIGLAgEQFMAA5AMHBkwaNKBAZUED
      BBa4HMgAQQGXDhgUMADgJkgDJQUSAGDRYQEADQYmAJDSYUeCByZelFiQqkOrA6U6HAqV6cUAADQK
      BCvzYs2bA2yqNIAAAIMBM+PKdRkQADs=
      ';
	$grkgifs{ldigamma} = '
      R0lGODlhGAAYAPcAAAQCBJSWlNTW1LSytFRSVKSmpOzy7Ly+vHR6dJyanOTi5FRWVKyqrPz+/MTC
      xAFn0OxpAnFmAmQAAF/eAGdWAAGaAIDC1wH2KwB+QQC2/wD21wC2Fo56JwEGpQAW1wCaFq/yTFkq
      UNf6xivKFv/aABUGAACGAADGAABKjwAmFgDuLgCqdAwWAHPSAAluAlI2dACSAAGyAAB2jgAOAJ8e
      dtCOAABeAAA+AICyVqR+H3b2AAAuAM7+AOnOAEvexQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANm3AP8BAP8AEP8AAAAXAABqAAAAGAABAO8AAOgAAEuf
      AADQwNgAO7AA0HYnEgBqACcAAAAAAAAnIwAcApiPAKSxAHb5AAC/AGwDRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfzur04TF/X34L+/u/9sYv+jgP92yv8AFf9Qr//wF/+az/+BFhUQ
      xgRSFgCfAACBAABzAACxAAD5dQC/AQgAzwAwFgB2ZAAAdOIOABOhAPf3AL+/AH8mBwGzAAD3AAC/
      AGQAh87wAfeadb+BAfcAAEEAAPcAAL8AABQAAFIAAJ8AAIEAAPp/ANoIAPf6AL+/AJDgAJRVAPxQ
      AL8AABWUrwSjFwB2hwAAAUBWJwCrAAD4AAC/AIwI/6Lm/3YA/wCA/yQgJ9tcAPcAAL+AAFwg2Deq
      sKkAdoGAAECYAAAQAAABAACAABQAuFIBpJ8AdoEAABMQCAGqtQAAS8CAABTkmFIcpJ9UdoEAAEB/
      8wAIsgD6TgC/ABX8zAROpAD1dgC/AIC0f0ukCAN2+tIAv9Trb6O2p3b5dgC/AP0E1/Tw//dO/78A
      f/8MSP/wp/9Odv8AAIDc5ACbHAD8VAC/AAO0fwCjCAB2+gAAv0MA5DoBHFwAVGIAAG/gAG9VAGtQ
      AHMAAFwAr3IASXQAR2bQAFyMSHAIp3IAdmUAAHAcSFwsp3Q8dmXQACH5BAAAAAAALAAAAAAYABgA
      BwhXABsIHEiwoMGDCBMqXMiwocOHECNKnKhQAIIFBDAuGBAxAYADAgckiBgAgIOBAjp+bKBgYskC
      BQJM9MhApEuTFBt4BEmx5EmKO3P6zOnx500DOZMqlRgQADs=
      ';
	$grkgifs{lepsilon} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpFRWVOTq5BQSFDQyNLS6tGRmZPz+/AD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOVDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABtlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJlAAAAAABwAAAAAABzAAAAAHBpALcAABVsAAAAAHBvABYAAPhuAHcAAP8ucP8At/9iFf8AAHxt
      cKIAtxJwFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QG/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0W6KlpxJOEgAAAJw84/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhiABkIHEiwoMGDCBMqXMiwocOHECNKnEjxoQIBAAAgWHAAYgAACwQuAEAAIgIABBMkMImyYgEA
      ASoyGJBxAYKSEF/GpHhS5smOAwmsdPgyQccDI4c6HGDgJAABBWRKnUpVYUAAOw==
      ';
	$grkgifs{leta} = '
      R0lGODlhGAAYAPcAAAQCBJSWlERCRNTa1LS6tGRmZCQiJBQSFKSqpFRWVPz+/MTKxHR2dAD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJlAAAAAAB0AAAAAABhAAAAAHAuALcAABViAAAAAHBtABYAAPhwAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhmABUIHEiwoMGDCBMqXMiwocOHEB8OMHAAgQIGAAAIeJhgAYADDBYoCACggEMACjIOGAjAAMSM
      BGE+lCmQZkObNhniRDmTZ02fN4HmXLjzpVCgEVMijTjUaFKCB5ZCFACAwNOrDwMCADs=
      ';
	$grkgifs{lgamma} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJnAAAAAABhAAAAAABtAAAAAHBtALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh0AB8IHEiwoMGDCBMqXMiwocOHBg8QABCA4AAAAhoaAMBxwcCNAxoiSPBAQMUHBwAYcAhAYIOM
      DwIAOABRYMsHCFbWLHmgAIKdAh0MYHByZwIFP4E+uFgUKAGlAg/AVJogqVIBN5UiyAoUwFOoDBxA
      HUt2Z0AAOw==
      ';
	$grkgifs{liota} = '
      R0lGODlhGAAYAPcAAAQCBJSWlERCRNTa1CQiJFRWVPz+/BQSFLS6tOTq5GRmZAAAAAD/RQD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOhDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABhlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJpAAAAAABvAAAAAAB0AAAAAHBhALcAABUuAAAAAHBiABYAAPhtAHcAAP9wcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGP9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGAATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WKKlpxJOEgAAAJw85vml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhGAA0IHEiwoMGDCBMqXMiwocOHECNKnEixosQEAQoAoHgAgMeKAz5WFEmR5ESTElFGVAlR5IGJ
      BAAMCKBgIoKYAizq3MkwIAA7
      ';
	$grkgifs{lkappa} = '
      R0lGODlhGAAYAPcAAAQCBISGhMTKxERCRCQiJKSqpOTq5FRWVBQSFJSWlNTa1DQyNLS6tPz+/GRm
      ZAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJrAAAAAABhAAAAAABwAAAAAHBwALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhmABsIHEiwoMGDCBMqXMiwocOHECNKnEiRoYEEBwAQFLAAwACGBAgA0CgQYwACCxyOFFgggMSV
      BRxMHFmAAMWRHRPM1ChSwEuNChAg+CmQAYCUEFeWBHBAwUOlAh2MJFmxqtWrCgMCADs=
      ';
	$grkgifs{lkoppa} = '
      R0lGODlhGAAYAPcAAAQCBIyOjNTW1FRSVKyyrPTy9GxqbKSmpJSWlNze3GRmZFxWXLy+vPz+/Jya
      nDw6PNzW3FRWVLS2tPT29Hx6fJSalOTi5AH2KwB+QQC2/wD21wC2Fo56JwEGpQAW1wCaFq/yTFkq
      UNf6xivKFv/aABUGAACGAADGAABKjwAmFgDuLgCqdAwWAHPSAAluAlI2dACSAAGyAAB2jgAOAJ8e
      dtCOAABeAAA+AICyVqR+H3b2AAAuAM7+AOnOAEvexQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANu3AP8BAP8AEP8AAAAXAABqAAAAGAABAO8AAOgAAEuf
      AADQwNgAO7AA0HYnEgBqACUAAAAAAAAnIwAcApiPAKSxAHb5AAC/AGwDRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfzur04TF/X34L+/u/9sYv+jgP92yv8AFf9Qr//wF/+az/+BFh8Q
      xgRSFgCfAACBAABzAACxAAD5dQC/AQgAzwAwFgB2ZAAAdOIOABOhAPf3AL+/AH8mBwGzAAD3AAC/
      AGQAh87wAfeadb+BAfcAAEEAAPcAAL8AABQAAFIAAJ8AAIEAAPp/ANoIAPf6AL+/AJDgAJRVAPxQ
      AL8AAB+UrwSjFwB2hwAAAUBWJQCrAAD4AAC/AIwI/6Lm/3YA/wCA/yQgJdtcAPcAAL+AAFwg2Deq
      sKkAdoGAAECYAAAQAAABAACAABQAuFIBpJ8AdoEAABMQCAGqtQAAS8CAABTkmFIcpJ9UdoEAAEB/
      8wAIsgD6TgC/AB/8zAROpAD1dgC/AIC0f0ukCAN2+tIAv9TrbaO2p3b5dgC/AP0E2fTw//dO/78A
      f/8MSP/wp/9Odv8AAIDc5ACbHAD8VAC/AAO0fwCjCAB2+gAAv0MA5DoBHFwAVGIAAG/gAG9VAGtQ
      AHMAAFwAr3IASXQAR2bQAFyMSHAIp3IAdmUAAHAcSFwsp3Q8dmXQACH5BAAAAAAALAAAAAAYABgA
      BwhfABsIHEiwoMGDCBMqXMiwocOHECM2EACAgMSBAQBMuCgQgAGOEwEcAOkAQAKQDwAMiDBgwQCI
      CQDInBkBZAEACEASACAAJAUAIBsAUAAypkWOCABYACmAQdCnUKMyDAgAOw==
      ';
	$grkgifs{llambda} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOZDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABplAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJsAAAAAABhAAAAAABtAAAAAHBiALcAABVkAAAAAHBhABYAAPguAHcAAP9icP8At/9tFf8AAHxw
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WqKlpxJOEgAAAJw85Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiBAB8IHEiwoMGDCBMqXMiwIUMBABw4NBhAwYMEBSYSZLBAoEWNAgEMlAiyYIMGJQkeIJnywQEG
      LQUaENnyAAAAKFMGAEDAQEsEABYg0AnAooKcGgkAGPCgAEuHBQAIGEhgIM2FSpkKFOAzwdCFDXgS
      jHrT50KIGQk6AAAzptu3DAMCADs=
      ';
	$grkgifs{lmu} = '
      R0lGODlhGAAYAPcAAAQCBJSWlERCRNTa1CQiJGRmZLS6tBQSFFRWVPz+/DQyNHR2dMTKxAD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOpDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABZlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJtAAAAAAB1AAAAAAAuAAAAAHBiALcAABVtAAAAAHBwABYAAPgAAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VqKlpxJOEgAAAJw86Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhlABMIHEiwoMGDCBMqXMiwocOHECNKJAgAAEWLDytehKhxYEeHHxOEZBhy5MKSGEGmFLmS5EqT
      ClEKPNCwYoEEDBYcADAgwE2SAgAQMJDAAAEAAkBOHGigZUQETjlGfShAwdKlAQEAOw==
      ';
	$grkgifs{lnu} = '
      R0lGODlhGAAYAPcAAAQCBKSqpERCRNTa1CQiJGRmZPz+/BQSFLS6tFRWVOTq5DQyNHR2dAD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOpDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABZlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJuAAAAAAB1AAAAAAAuAAAAAHBiALcAABVtAAAAAHBwABYAAPgAAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VqKlpxJOEgAAAJw86Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhiAA0IHEiwoMGDCBMqXMiwocOHECNKnEix4sMBDAgUKLhgQUMBCwAcKCjyIQEACAgC2OgwwEqV
      CiACADAwAMuHCQAEEEggJkSXCQzYnHiAZs+JBQAsuBkRwUyfRJlanEpVYUAAOw==
      ';
	$grkgifs{lomega} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJvAAAAAABtAAAAAABlAAAAAHBnALcAABVhAAAAAHAuABYAAPhiAHcAAP9tcP8At/9wFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiKAB8IHEiwoMGDCBMqXMiwocOHECNKnEix4QIDBAAIBEDAwIKGBQAwaECwAQMABRYu4DjQgIKB
      Jz8mNIByIACNAhsAMKAw4wGbODcSUHiTIAAERoMeLDpQwUugCk8STJDS5tCEAWoKdDpQJ8+oBH4m
      QDAgwYMDDBD8XOgAAQABHxtkhFuxrt27DAMCADs=
      ';
	$grkgifs{lomicron} = '
      R0lGODlhGAAYAPcAAAQCBISGhFRWVMTKxCQiJOTq5KSqpHR2dBQSFGRmZNTa1DQyNPz+/LS6tAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOVDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABtlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJvAAAAAABtAAAAAABpAAAAAHBjALcAABVyAAAAAHBvABYAAPhuAHcAAP8ucP8At/9iFf8AAHxt
      cKIAtxJwFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QG/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0W6KlpxJOEgAAAJw84/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhuABkIHEiwoMGDCBMqXMiwocOHECNKnEjx4QABAAAsaBDRAAKOBTAeeFgAgAGCBAAMcJgAQEED
      AAQ4TFmwpMuGGQ3mbIgAgIKCAAg4xBgAaAKHAwAgIAizwMMDGp0OQHASYoMFGQWsrMi1q1eHAQEA
      Ow==
      ';
	$grkgifs{lphi} = '
      R0lGODlhGAAYAPcAAAQCBISGhMTKxERCRCQiJKSqpOTq5FRWVBQSFJSWlNTa1DQyNLS6tPz+/GRm
      ZAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJwAAAAAABoAAAAAABpAAAAAHAuALcAABViAAAAAHBtABYAAPhwAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiCABsIHEiwoMGDCBMqXMiwocOHECNKLOgAQQMFAwAQCPBwAQIBDQ6AdADAQcMAABIIBDAwYwGG
      CwAoWDmQAYABDAGwpDlQZ86dDYAGFYqQAFChGhmSZMCzQQEAHBcquNmUAAGHTw8YYFnA6kyHCg4g
      0DlA5USiEtFGVAuR7UO3ExEGBAA7
      ';
	$grkgifs{lpi} = '
      R0lGODlhGAAYAPcAAAQCBISGhMTKxERCRCQiJKSqpOTq5GRmZBQSFJSWlNTa1DQyNLS6tPz+/HR2
      dAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOpDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABZlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJwAAAAAABpAAAAAAAuAAAAAHBiALcAABVtAAAAAHBwABYAAPgAAHcAAP8AcP8At/8AFf8AAHwA
      cKIAtxIAFQAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFQAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABZw
      cwC3cgAVTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VqKlpxJOEgAAAJw86Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhyABsIHEiwoMGDCBMqXMiwocOHECNKnJhQAAEAGDNmbIhAo0cADB0sMNAAZAMBAAI4JCCggQIE
      AgOkjMhggMADAApEdGCzwQAALSEScCDwYkSZKkuadKgAY1CnLxtehFk044GGPxMMtAigJ8WvYMOK
      fRgQADs=
      ';
	$grkgifs{lpsi} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJOTq5GRmZBQSFJSWlNTa1DQyNPz+/HR2dAD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJwAAAAAABzAAAAAABpAAAAAAAuALoAABRiAAAAAHBtABYAAPhwAHcAAP8AAP8Auv8AFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiFABcIHEiwoMGDCBMqXMiwocOHECNKXEAAgACCAAgKAEBAYUUDAzMKNMBxYYCSAkVSBBBg4QAA
      KmMCGLCwAMwEKQXaBIBzIUyaC0S+VKlQAQAEORcgAKCg4UmQQUeydEjgQNIDVh0mOKDAZgEFB3o6
      LMCgIgEDBSZGVZuULdGJbyXGZZswIAA7
      ';
	$grkgifs{lrho} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJGRmZOTq5KSqpBQSFFRWVNTa1DQyNHR2dPz+/LS6
      tAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJyAAAAAABoAAAAAABvAAAAAAAuALoAABRiAAAAAHBtABYAAPhwAHcAAP8AAP8Auv8AFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhzABsIHEiwoMGDCBMqXMiwocOHECM2GJAAAIAEAyIyYCDwAAIABx46AEBQwUcHDgWQJBgAwAKH
      FgsqiNmQJkGbC3EKdAlz5cCZAXpmHJiAwEOLAjIaKIBAwVEAClQiKBBRZ1WfEhtYfWiAZ9YGIwV8
      HTs2IAA7
      ';
	$grkgifs{lsampi} = '
      R0lGODlhGAAYAPcAAAQCBIyKjNTW1KyyrFRWVPTy9Ly+vGxqbJyanNze3LSytGRmZPz+/Dw6PJSW
      lFxWXPT29LzCvHx6fKSmpOTi5LS2tIDi1wH2KwB+QQC2/wD21wC2Fo56JwEGpQAW1wCaFq/yTFkq
      UNf6xivKFv/aABUGAACGAADGAABKjwAmFgDuLgCqdAwWAHPSAAluAlI2dACSAAGyAAB2jgAOAJ8e
      dtCOAABeAAA+AICyVqR+H3b2AAAuAM7+AOnOAEvexQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANu3AP8BAP8AEP8AAAAXAABqAAAAGAABAO8AAOgAAEuf
      AADQwNgAO7AA0HYnEgBqACUAAAAAAAAnIwAcApiPAKSxAHb5AAC/AGwDRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfzur04TF/X34L+/u/9sYv+jgP92yv8AFf9Qr//wF/+az/+BFjsQ
      xgRSFgCfAACBAABzAACxAAD5dQC/AQgAzwAwFgB2ZAAAdOIOABOhAPf3AL+/AH8mBwGzAAD3AAC/
      AGQAh87wAfeadb+BAfcAAEEAAPcAAL8AABQAAFIAAJ8AAIEAAPp/ANoIAPf6AL+/AJDgAJRVAPxQ
      AL8AADuUrwSjFwB2hwAAAUBWJQCrAAD4AAC/AIwI/6Lm/3YA/wCA/yQgJdtcAPcAAL+AAFwg2Deq
      sKkAdoGAAECYAAAQAAABAACAABQAuFIBpJ8AdoEAABMQCAGqtQAAS8CAABTkmFIcpJ9UdoEAAEB/
      8wAIsgD6TgC/ADv8zAROpAD1dgC/AIC0f0ukCAN2+tIAv9TrbaO2p3b5dgC/AP0E2fTw//dO/78A
      f/8MSP/wp/9Odv8AAIDc5ACbHAD8VAC/AAO0fwCjCAB2+gAAv0MA5DoBHFwAVGIAAG/gAG9VAGtQ
      AHMAAFwAr3IASXQAR2bQAFyMSHAIp3IAdmUAAHAcSFwsp3Q8dmXQACH5BAAAAAAALAAAAAAYABgA
      BwhhABkIHEiwoMGDCBMqXMiwocOHEB8aiBCxIAQJDwRUJDgAwISNAwUAkABSYMePIDsCSFBRwIEJ
      EAAEqEihAAOVGyEsqEABAIWcAhtUKMkggAOiERAQpbCAKAMCTqNKnWowIAA7
      ';
	$grkgifs{lsigma} = '
      R0lGODlhGAAYAPcAAAQCBISGhNTa1ERCRCQiJKSqpPz+/BQSFJSWlOTq5GRmZDQyNLS6tAD/AAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJzAAAAAABpAAAAAABnAAAAAABtALoAABRhAAAAAHAuABYAAPhiAHcAAP9tAP8Auv9wFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhuAA0IHEiwoMGDCBMqXMiwocOHECNKnEjRYYEBADJqBOBQwcaPDQtkDJDAgIIAEDEiILhAwcOM
      BUUycAizIIAFDgkAKEmwJsMAAAoQTADgwMMDRgcCdelQwIEFAgwweBoxgYIDAAigrMi1q9eHAQEA
      Ow==
      ';
	$grkgifs{lsigmae} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJOTq5KSqpFRWVBQSFNTa1DQyNPz+/LS6tGRmZAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOZDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABplAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJzAAAAAABpAAAAAABnAAAAAABtALoAABRhAAAAAHBlABYAAPguAHcAAP9iAP8Auv9tFP8AAHxw
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WqKlpxJOEgAAAJw85Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhiABcIHEiwoMGDCBMqXMiwocOHECNKPBiAAAAEBiQqAMDxYkQBBwosYCBAAUQDAiYOPMBApUAE
      LgUCiLkAgEiXBxQkcJkAQUcABHZCTCDgZ0qXA2bGVOrSpMsGLTUCzUhTYUAAOw==
      ';
	$grkgifs{lstigma} = '
      R0lGODlhGAAYAPcAAAQCBIyKjNTW1FRSVKyqrGxqbJyanPT29Ly+vHR6dDw6PJSWlNze3FxWXHx6
      fIyOjFRWVLSytKSmpPz+/MTCxDw+PNzi3Hx+fAB+QQC2/wD21wC2Fo56JwEGpQAW1wCaFq/yTFkq
      UNf6xivKFv/aABUGAACGAADGAABKjwAmFgDuLgCqdAwWAHPSAAluAlI2dACSAAGyAAB2jgAOAJ8e
      dtCOAABeAAA+AICyVqR+H3b2AAAuAM7+AOnOAEvexQAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANq3AP8BAP8AEP8AAAAXAABqAAAAGAABAO8AAOgAAEuf
      AADQwNgAO7AA0HYnEgBqACYAAAAAAAAnIwAcApiPAKSxAHb5AAC/AGwDRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfzur04TF/X34L+/u/9sYv+jgP92yv8AFf9Qr//wF/+az/+BFlEQ
      xgRSFgCfAACBAABzAACxAAD5dQC/AQgAzwAwFgB2ZAAAdOIOABOhAPf3AL+/AH8mBwGzAAD3AAC/
      AGQAh87wAfeadb+BAfcAAEEAAPcAAL8AABQAAFIAAJ8AAIEAAPp/ANoIAPf6AL+/AJDgAJRVAPxQ
      AL8AAFGUrwSjFwB2hwAAAUBWJgCrAAD4AAC/AIwI/6Lm/3YA/wCA/yQgJttcAPcAAL+AAFwg2Deq
      sKkAdoGAAECYAAAQAAABAACAABQAuFIBpJ8AdoEAABMQCAGqtQAAS8CAABTkmFIcpJ9UdoEAAEB/
      8wAIsgD6TgC/AFH8zAROpAD1dgC/AIC0f0ukCAN2+tIAv9TrbqO2p3b5dgC/AP0E2PTw//dO/78A
      f/8MSP/wp/9Odv8AAIDc5ACbHAD8VAC/AAO0fwCjCAB2+gAAv0MA5DoBHFwAVGIAAG/gAG9VAGtQ
      AHMAAFwAr3IASXQAR2bQAFyMSHAIp3IAdmUAAHAcSFwsp3Q8dmXQACH5BAAAAAAALAAAAAAYABgA
      BwhoACcIHEiwoMGDCBMqXMiwocOHECNKnEjR4QECDwZAGFBBwEMBAEKKVPDwAAACFCggoODxoQQH
      FScYMBBzAcmKIAswqGggpIICCyxIpOCggkgEMQ0kiCngwsQADhYAiDCxQUiqMbMyDAgAOw==
      ';
	$grkgifs{ltau} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRNTa1CQiJKSqpGRmZPz+/BQSFJSWlFRWVOTq5DQyNLS6tHR2
      dAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOlDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABdlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJ0AAAAAABhAAAAAAB1AAAAAAAuALoAABRiAAAAAHBtABYAAPhwAHcAAP8AAP8Auv8AFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QF/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0V6KlpxJOEgAAAJw85/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhaAA8IHEiwoMGDCBMqXMiwocOHECNKnEjRYQEEADJqfLgAo8aNDh0oODAAgAGJBBYcKAAgQEUH
      ABJUFABgQEUCACoeyKgzo8wGBFB+dBlxAAMACBzoXMq06cKAADs=
      ';
	$grkgifs{ltheta} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJGRmZOTq5BQSFKSqpFRWVNTa1DQyNHR2dPz+/AD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOdDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABllAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJ0AAAAAABoAAAAAABlAAAAAAB0ALoAABRhAAAAAHAuABYAAPhiAHcAAP9tAP8Auv9wFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WaKlpxJOEgAAAJw85fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiDABsIHEiwoMGDCBMqXMiwocMGBQ4ASKDg4cAFBQQyOFDxYQIBBAWAdGgAAAKCCAAMcMgAQEeB
      CgBkbCgAgEEAIxlKvGmzIYCfQIM6/MlzaE+CRGkCMECwZM6FBVQSHACAgUOqVgcGcPlQAAGCBBJY
      NHBgZoEFFgUaiCozrdu3cOMuDAgAOw==
      ';
	$grkgifs{lupsilon} = '
      R0lGODlhGAAYAPcAAAQCBJSWlFRWVNTa1CQiJLS6tHR2dPz+/BQSFKSqpGRmZOTq5DQyNMTKxAD/
      AAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOVDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABtlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJ1AAAAAABwAAAAAABzAAAAAABpALoAABRsAAAAAHBvABYAAPhuAHcAAP8uAP8Auv9iFP8AAHxt
      AKIAuhJwFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QG/9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGwATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0W6KlpxJOEgAAAJw84/ml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwhuAA8IHEiwoMGDCBMqXMiwocOHECNKnEiR4QACCBIMRKDgoYAGABAMbICAgUMABwCgHJgAQICH
      KgkuAGDy5MqBMW0WzNmQp0AABGDePADSwEMGAAYMNIBgwcMCNJ0GQFAgYgGkAAQorci1q1eHAQEA
      Ow==
      ';
	$grkgifs{lxi} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOpDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABZlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJ4AAAAAABpAAAAAAAuAAAAAABiALoAABRtAAAAAHBwABYAAPgAAHcAAP8AAP8Auv8AFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VqKlpxJOEgAAAJw86Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwiBAB8IHEiwoMGDAxMgQMiwIIAFAgsQWNjQIIEEDxgAAOCgosEFCjYKKODxYACMJRFSTHmQQYEB
      BggAIMBS4AEEMmcGqPlAwACeBBlABCowwE6iAgkcQCoQAFOBCH4yNSD0KQKRGwEI4GngalYABp4m
      cPqULFMGTw00IKqRwNqnDQMCADs=
      ';
	$grkgifs{lzeta} = '
      R0lGODlhGAAYAPcAAAQCBJSWlERCRNTa1CQiJLS6tGRmZPz+/BQSFKSqpFRWVOTq5DQyNMTKxHR2
      dAD/AACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOhDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABhlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhsALEA
      ABJ6AAAAAABlAAAAAAB0AAAAAABhALoAABQuAAAAAHBiABYAAPhtAHcAAP9wAP8Auv8AFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QGP9gAP8TAP8AAADh/wAb/wDo/wB3/wDoGAATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0WKKlpxJOEgAAAJw85vml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwh3AA8IHEiwoMGDBAcwQMiwIIIGAhsIANDw4MMDDgAASFDRYAICABAYgNjR4AAHJRkqSInQAUmW
      BBcIgGkwQACaBQUMwEkQAU+CFH8KDCoUQQGhBwxc/DkAgcanOmEOUPBU40qhAYj+1MpzoVADR3Ey
      AEDgJtKGAQEAOw==
      ';
	$grkgifs{nch} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOpDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABZlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhuALEA
      ABJjAAAAAABoAAAAAAAuAAAAAABiALoAABRtAAAAAHBwABYAAPgAAHcAAP8AAP8Auv8AFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFv9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFgATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VqKlpxJOEgAAAJw86Pml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      Bwi8AB8IHEiwoMGDCBMqXMiwocOHEBMeIAAgAMEBAAQ8mAigwECMBAQaAEBywcCRAx6MBIBgoICO
      AhEkeCDA4kYABgQScPBAgUeQAwEIbKDxQQAABwQKfbAg50uPBpciyGmQANCDAg4UaIn1KUIHAxjY
      NHg0JMIECrhihYkQ49iCVxOaXbsU4YGiBkEqSHlWbcGnCWYifHkQ6AIFQQsiqEvQ6wOrRhkUBDD3
      I+WBDkhWLMiA51+2Al/ijUh6YUAAOw==
      ';
	$grkgifs{ng} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOtDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABVlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhuALEA
      ABJnAAAAAAAuAAAAAABiAAAAAABtALoAABRwAAAAAHAAABYAAPgAAHcAAP8AAP8Auv8AFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VaKlpxJOEgAAAJw86fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwilAB8IHEiwoMGDCBMqXMiwocOHECNCPEAAQACCAwAIoGgRo0aBBgCIXDAw5ICQI0sCGCAQQYIH
      Ai4+OADAwAOXMGXStCkQgMAGAgQGAHDggc8HQIUSPXgUAU+CTZ8W3FgAwUGqVhE6GMBAZsGtXRMm
      UJDV4NiyBzN6Lah2IQGFbxUeCIpw7sIEaAviXSjg6FW/CBEALih4IYC4TBEjZOAgIWOJDAMCADs=
      ';
	$grkgifs{nk} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOtDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABVlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhuALEA
      ABJrAAAAAAAuAAAAAABiAAAAAABtALoAABRwAAAAAHAAABYAAPgAAHcAAP8AAP8Auv8AFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VaKlpxJOEgAAAJw86fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwirAB8IHEiwoMGDCBMqXMiwocOHECNCPEAAQACCAwAIOJBAAQCMDDQ+MACg5IKBJAcQqPhRYMcA
      BBg8QJDggYCLDw4AMDCwpMACOHsKbCBAYAAAB3p+LMAzYUsETQWWLEBg4cYCCAqWDFkzoYMBDIJK
      /VhxQMKOWbV+XIAg7cGMYscOBSATYVWDPl0CUHCy4IGieFsKJJl3YAK3Em0KToxgsUQAdxM/YOBA
      suWAADs=
      ';
	$grkgifs{nx} = '
      R0lGODlhGAAYAPcAAAQCBISGhERCRMTKxCQiJKSqpGRmZOTq5BQSFJSWlFRWVNTa1DQyNLS6tHR2
      dPz+/ACE2AClIQASEwAAAAAaxAACowAAEgAAABAIAAAAAgAAAAAAAACEgAClpQASEgAAABDh9KJm
      ZBL4+wB3dwBg8ADcMAD8+AB3dxbA/yZm//v4/3d3/wB4kABmpRP4EgB3AMgAMmDsjRP9/AB/dwAA
      eAAAEwAAEwAAAIADCqQAAhIAAAAAADcAGrYAAksAAAAAAGYgAABCAACOAAAAAJgAAKQAABKOAAAA
      AGwkMKSjpxISEgAAAHICZHIAp04AEgAAAOtDAP8AAP86AP8AAABcAAAAAAByAAAAAFh0ALUAAEtm
      AAAAABhcALEAABJ0AAAAABVlAAAAAABzAAAAAJh0AKQAABJcAAAAAGwxAKQAABJcAAAAABhuALEA
      ABJ4AAAAAAAuAAAAAABiAAAAAABtALoAABRwAAAAAHAAABYAAPgAAHcAAP8AAP8Auv8AFP8AAHwA
      AKIAuhIAFAAAAK0AADkAAOkAAHcAAAAAAAAAsBMAFAAAAAAAAAAAAAAAAAAAAAgAB3gAABUAAAAA
      ABYAEAAApQAAEsAAANAAAGAAABMAAAAAAACQAACjAAASAAAAAH6tAAATAADpAMB3AAAAAAAAAAAA
      AAAAAP8AqP8ApP8AEv8AAP/QFf9gAP8TAP8AAADh/wAb/wDo/wB3/wDoFQATAADpAAB3AACwGACj
      sQASEgAAAADgAAAbABPoAAB3AGgAuAAApAAAEgAAAAAArmAAgRMASwAAAKkAmDMApOkAEncAABYA
      cwC6cgAUTsAAAAG0zKOkpBISEgAAAABBAAETAADpAAB3ACA0VaKlpxJOEgAAAJw86fml/xJO/wAA
      f5zgQPkbpxLoEgB3APSwGGSjsfsSEncAAHAAABYAAPgAAHcAAP+AGP/7sf9PEv8AAFwAGKMAExIA
      6QAAd6UArxoAAukAR3cAAADsQACjpxMSEgAAAABFQAAApwAAEgAAACH5BAAAAAAALAAAAAAYABgA
      BwjGAB8IHEiwoMGDCAUmQJCw4UAACwQWIMDQYUECCR4wAADAgcWCCxRwFFDgo8EAGU0erHjwAAEA
      AQgOACBgIIMCAwy8JDDQAEeIPQEMGHgAwUsABGIKRJBRgNIDAAwQFDD0IACBDWo+CADggM2IFq8+
      QCBVYAClFgUcKMDyAQGvHx0MYID2gdiPCRS0HVvV4sy6DwwwAGuRp0EEI39qLXhgcUEDiH9GNbjQ
      ZIK7AwVgdrh5bOeEDAwiNWmggUEGHhtuJGBaZcOAADs=
      ';
	$grkgifs{oulig} = '
      R0lGODlhGAAYAPcAAAQCBISChMTCxERCRCQiJNzi3JyenBQSFMzSzGRiZDQyNIySjOzy7KyurCQq
      JHRydPT69AwKDMTKxBwaHNTa1Ly2vIyKjFRSVDw6PJyanLSutDQuNHx6fAwGDBwWHJSalPTy9Cwq
      LPz6/MzKzNza3AQGBISGhMTGxExKTCQmJOzu7KyqrBQWFNTS1GxubDQ2NJSSlKyyrHR2dBQOFBwe
      HIyOjFxeXDw+PLSytHx+fPT29CwuLPz+/MzOzNze3AAAFWYArwAAFwD/SwD/AJgAZaQCAHYPRAAo
      vGz3YqS/gHa2AQBRAPJoALJzAE4oAAAAANy3AP8BAP8AEP8AAAAXAABqAAAAGAABAO8AAOgAAEuf
      AADQwNgAO7AA0HYnEgBqACQAAAAAAAAnIwAcApiPAKSxAHb5AAC/AGwDRKQAdHbeAAB0AOQDjxwA
      FlTPSABAdH8AAAgAAPpGxb+XFfwAr04AF/VW4L+yu/8DYv8AgP8Iyv90Ff8Cr/8AF/8nz/8GFhRW
      xgEfFtYvAAECAIBzAHSxALf5dTK/ASgAzyswFgN2ZAAAdEeqAAABAHYTAAAEAGC8B6IBAHYAAACQ
      AKlph3PPAfcAdb9AAQRoAAHPAAAAAAAAABYAAAAAAAAAAAAAAEN/ADoIAFz6AGK/AG/gAG9VAGtQ
      AHMAAFyUr3KjF892hxYAAQdWJACrAAD4AAC/AI4I/3Lm/8QA/0aA/wAgJABcAAAAAACAAIcg2AGq
      sAAAdgCAAJiYAKIQAHYBAACAAHsAuLcBpPcAdr8AAPcQCEGqtfcAS7+AAJDkmJQcpPxUdr8AAJZ/
      87cIsvf6Tr+/AJD8zJROpPz1dr+/AIe0fwGkCAB2+gAAv7DrbKK2p3b5dgC/ACgE2rjw//dO/78A
      f1wMSDfwp6lOdoEAAPfc5EGbHPf8VL+/AJC0f5SjCPx2+r8Av04A5LgBHPcAVL8AAAHgAABVAABQ
      AAAAAAEArwAASTMARwLQALeMSAEIp88AdkAAAAAcSAAsp0Y8dpfQACH5BAAAAAAALAAAAAAYABgA
      Bwi7AHkIHEiwoMGDCBMqXMiwocOHECOC6AEhIkEVLSzyEGHCwoYdIAQyWGCi4sIWAAB0SCBCoIYS
      ADQwhAGghAccAiHcKNHBwEaFBTx4mIGiQYMXKneQaLiiQcqaKh1IcDjiRAeoHWbIbEhhwA2VBy48
      CGHDpEIQN652gCGAhIgPHWowjFGC54CBDHYAeMCwgsoOHAa2KBHBBUMfBFJ2CEAjRIS6GRkWGIDB
      g0qVKTJELGBCRoAAkTWKHq0xIAA7
      ';
}
1;
